.\" -*- nroff -*-
.\"
.\" Copyright (c) 1996 Doug Rabson
.\"
.\" All rights reserved.
.\"
.\" This program is free software.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE DEVELOPERS ``AS IS'' AND ANY EXPRESS OR
.\" IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
.\" OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
.\" IN NO EVENT SHALL THE DEVELOPERS BE LIABLE FOR ANY DIRECT, INDIRECT,
.\" INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
.\" NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
.\" DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
.\" THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
.\" (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
.\" THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
.\"
.\" $FreeBSD: src/share/man/man9/VOP_SEEK.9,v 1.1.2.1 1999/09/05 11:27:13 peter Exp $
.\"
.Dd July 24, 1996
.Os
.Dt VOP_SEEK
.Sh NAME
.Nm VOP_SEEK
.Nd seek to a given location in a file
.Sh SYNOPSIS
.Fd #include <sys/vnode.h>
.Ft int
.Fn VOP_SEEK "struct vnode *vp" "off_t oldoff" "off_t newoff" "struct ucred *cred"
.Sh DESCRIPTION
This seeks to a given location in a file, possibly extending the file.
Most filesystems do not implement this entry point and automatically
extend the file when it is written to.
In fact, the only place in the entire kernel where this is called is
from the union filesystem and then only to implement its own VOP_SEEK
entry point.
.Pp
Its arguments are:
.Bl -tag -width 8X
.It Ar vp
the vnode of the file
.It Ar oldoff
an offset
.It Ar newoff
another offset
.It Ar cred
the caller's credentials
.El
.Sh PSEUDOCODE
.Bd -literal
int
vop_seek(struct vnode *vp, off_t oldoff, off_t newoff, struct ucred *cred)
{
    return 0;
}
.Ed
.Sh SEE ALSO
.Xr vnode 9
.Sh AUTHORS
This man page was written by Doug Rabson.

